package polyglot.ext.ibex.types;

import polyglot.types.*;
import polyglot.ext.jl.types.*;
import polyglot.util.*;
import java.util.*;

public class Nonterminal_c extends MethodInstance_c implements Nonterminal {
    Type type;
    List choices;
    boolean isStart;

    public Nonterminal_c(IbexTypeSystem ts, Position pos, ParserType container,
                         Flags flags, Type type, String name, List choices,
                         boolean isStart) {

        super(ts, pos, container, flags, type, name, Collections.EMPTY_LIST, Collections.EMPTY_LIST);
        this.type = type;
        this.choices = choices;
        this.isStart = isStart;

        // Get the MethodInstance for GLRParser.parser(int, int)
        // and use it to set the throw types.
        List formalTypes = new ArrayList(2);
        formalTypes.add(ts.Int());
        formalTypes.add(ts.Int());

        MethodInstance pmi;

        try {
            pmi = ts.findMethod(ts.runtimeGLRParserType(), "parse",
                        formalTypes, container);
        }
        catch (SemanticException e) {
            throw new InternalCompilerError(e);
        }

        this.excTypes = pmi.throwTypes();
    }

    public Type returnType() {
        return type;
    }

    public MethodInstance returnType(Type t) {
        Nonterminal_c n = (Nonterminal_c) super.returnType(t);
        n.setSymbolType(t);
        return n;
    }

    public Type symbolType() {
        return type;
    }

    public void setSymbolType(Type type) {
        this.type = type;
    }

    public List choices() {
        return choices;
    }

    public void setChoices(List choices) {
        this.choices = choices;
    }

    public boolean isStart() {
        return isStart;
    }

    public boolean isCanonical() {
        return type.isCanonical();
    }

    public String toString() {
        return name;
    }
}
